(*
open Mlgdbm;;

let db = dbopen "testdatabase.pag";;

replace db "a" "aaaaaaa";;
replace db "b" "b";;
Printf.printf "find a = %s\n" (find db "a");;
Printf.printf "find c? %b\n" ((find_opt db "c") = None);;
Printf.printf "exists b = %b\n" (exists db "b");;
sync db;;
replace db "a" "aaaaaaaaaaaaaaa";;
Printf.printf "find a = %s\n" (find db "a");;

let fk = firstkey db;;
Printf.printf "firstkey=%s\n" fk;;
let nk = nextkey db fk;;
Printf.printf "nextkey=%s\n" nk;;
try ignore (nextkey db nk); failwith "!" with Not_found -> Printf.printf "nextkey Not_Found\n";;

replace db "c" (Marshal.to_string (Int32.of_int 3) [Marshal.No_sharing;Marshal.Compat_32])
let i = (find_unmarshal db "c" : int32);;
Printf.printf "find c->3 : %ld\n" i;;
*)

open Bitlist;;
let print2 bl =
  print2 Format.std_formatter bl; Format.pp_print_char Format.std_formatter '\n';
  Format.pp_print_flush Format.std_formatter ();;

let bl = of_bools [false;false;false;false;false;false];;
Printf.printf "6 falses: "; print2 bl;;
set bl 2 true;;
let (s,_,_) = to_string bl;;

Hashlib.bools_blit_bitlist [true;true;true;true] s 4 (-1);;
Printf.printf "4 blits   "; print2 bl;;

(*
let (s, _, _) = to_string bl in
Printf.printf "<%s>\n" (Hashlib.bebits_hexstring s);;
 *)

let bl2 = cut_prefix bl 2;;
Printf.printf "2 cuts    "; print2 bl2;;

(*let bl3 = rev_append [true;true;false;false;false;true;true;true] bl2;;*)
(*let bl3 = rev_append [false;false;false;false] bl2;;*)
let bl3 = rev_append [false;true;true] bl2;;
Printf.printf "3 "; print2 bl3;;

let bl4 = of_bools [true; true; true; true; true; true; true; true; true; true];;
let (s, _, _) = to_string bl in
Printf.printf "Str <%s>\n" (Hashlib.bebits_hexstring s);;

let bl1a = of_bools [true; true];;
let bl1 = of_bools [true; true; true];;
let bl2 = of_bools [true; true];;
let bl1c = cut_prefix bl1 1;;

(*print2 bl1a;
print2 bl1c;
print2 bl2;*)

Printf.printf "Fast compare if bit-aligned: %b\n" (Bitlist.eq bl1a bl2);;
Printf.printf "Slow-compare if non-aligned: %b\n" (Bitlist.eq bl1c bl2);;
